<?php

 
// This is analogous to the GirlNeuron class.
// We input data as we descend the pyramidal steps.  The output rises back to the top.
class PyramidAscent extends PyramidMovement {
	
	
	function __construct(PyramidTier &$pyramidTier){

		parent::__construct($pyramidTier);
	}
	
	
	function finishedReceivingOutputFromLowerLevel(){

		$this->pyramidTier->receiveCharacter(SYMBOL_END);

		$this->pyramidTier->setCharacterStreamFromContextArr();
		
		$this->pyramidTier->resetContext();
		
		foreach($this->pyramidTier->characterStreamArr as $loop_Char){
		
			if($loop_Char == SYMBOL_END){
				continue;
			}
			
			$this->outputCharacter($loop_Char);
		}
		
		$this->outputCharacter(SYMBOL_END);
	}
	
	function honeyDo(){
		
		$this->pyramidTier->setCharacterStreamFromContextArr();
		
		$this->pyramidTier->resetContext();
		
		// We can't do a C27 Query... however, we can trust that the input which our wife received has been vetted.
		$c27ContextSignature = $this->pyramidTier->contextSignature;
		
		foreach($this->pyramidTier->characterStreamArr as $loop_Char){
			
			if(empty($this->pyramidTier->lowerLevel)){
				
				$this->outputCharacter($loop_Char);
			}
			else if($loop_Char == SYMBOL_END){
	
				$this->pyramidTier->receiveCharacter(SYMBOL_END);
			}
			else if($this->pyramidTier->checkIfCharacterCodeIsPartCluster(ord($loop_Char))){
				
				$this->pyramidTier->lowerLevel->pyramidDescent->inputData($c27ContextSignature, SYMBOL_END);

				$this->pyramidTier->receiveCharacter($loop_Char);
			}
			else{
				$this->pyramidTier->lowerLevel->pyramidDescent->inputData($c27ContextSignature, $loop_Char);	
			}
		}
		
		if($this->pyramidTier->lowerLevel){
			$this->pyramidTier->lowerLevel->pyramidDescent->inputData($c27ContextSignature, SYMBOL_END);	
		}
		else{
			
			$this->pyramidTier->receiveCharacter(SYMBOL_END);
			$this->pyramidTier->setCharacterStreamFromContextArr();
			$this->pyramidTier->resetContext();
		
			foreach($this->pyramidTier->characterStreamArr as $loop_Char){
				$this->outputCharacter($loop_Char);
			}

			$this->outputCharacter(SYMBOL_END);
		}
	}

	
	private function outputCharacter($character){
print "<font color='maroon'><b>Boy Output</b>:" .  htmlspecialchars($character) . "</font><br>";			
		if($this->childObj){
			// Polymorphism: This method exists for both sons and daughters.
			$this->childObj->inputFromTierBeneath($character);
		}
		else{
			$this->pyramidTier->receiveCharacter($character);
		}
	}
	
}


