<?php
 
// Build UI Components that are shared among action scripts.
class Widgets {

	static function buildHtmlNav(Templatex $htmlTemplateObj){
		
		$authObj = new Authenticate();
		
		$inventorObj = new Inventor();
		$inventorObj->loadInventor($authObj->getAccountID());
		
		$htmlTemplateObj->set_var("ACCOUNT_NAME", WebUtil::htmlOutput($inventorObj->getName()));
		$htmlTemplateObj->set_var("ACCOUNT_IMAGE_DESC", WebUtil::htmlOutput($inventorObj->getImageDesc()));
		$htmlTemplateObj->set_var("ACCOUNT_IMAGE_ID", $inventorObj->getImageID());
		
		// It is possible to register for an account without creating a Site Key.
		if($inventorObj->getImageDesc() == ""){
			$htmlTemplateObj->discard_block("root", "SiteKeyBL");
		}
		
		// Sets a security code (in a session variable) that must match up to a "hidden input" for all form submissions. 
		// This will mitigate "Cross-site Forgery" attacks.
		$htmlTemplateObj->set_var("FORM_SECURITY_CODE", WebUtil::getFormSecurityCode());
		
		// The "current URL" can be useful to send to other form actions so it has a place to return to after it is done.
		$currentUrl = basename($_SERVER['PHP_SELF']) . "?" . $_SERVER['QUERY_STRING'];
		
		$htmlTemplateObj->set_var("CURRENT_URL", WebUtil::htmlOutput(WebUtil::filterURL($currentUrl)));
		
		// The "URL Encoded URL" is needed when the "current URL" is placed within a name/value pair of a hyperlink.
		$htmlTemplateObj->set_var("CURRENT_URL_ENCODED", WebUtil::htmlOutput(urlencode(WebUtil::filterURL($currentUrl))));
	}
}

