<?php


require_once 'Boot.php';

$account = WebUtil::GetInput("account", FILTER_SANITIZE_EMAIL);
$pw = WebUtil::GetInput("pw", FILTER_SANITIZE_STRING_ONE_LINE);
$forward = WebUtil::GetInput("forward", FILTER_SANITIZE_URL);
$siteKeyID = WebUtil::GetInput("siteKeyID", FILTER_SANITIZE_INT);
$siteKeyDesc = WebUtil::GetInput("siteKeyDesc", FILTER_SANITIZE_STRING_ONE_LINE);
$action = WebUtil::GetInput("action", FILTER_SANITIZE_WORD_OR_NUMBER_NO_SPACES);
$changeAccountName = WebUtil::GetInput("changeAccountName", FILTER_SANITIZE_WORD_OR_NUMBER_NO_SPACES);
$rememberPassword = WebUtil::GetInput("rememberPassword", FILTER_SANITIZE_WORD_OR_NUMBER_NO_SPACES);
	
$inventorObj = new Inventor();

WebUtil::runInSecureModeHTTPS();

$maxSiteKeyID = 120;

$dbCmd = new DbCmd();

$t = new Templatex(".");

$t->set_file("root", "login-template.html");

$t->set_var("TRANSFER_ADDRESS", WebUtil::htmlOutput($forward));
$t->set_var("TRANSFER_ADDRESS_ENCODED", urlencode($forward));
$t->set_var("FORM_SECURITY_CODE", WebUtil::getFormSecurityCode());


if(!empty($action)){
	
	if($action == "ShowSiteKeySelections"){
		
		if(!Authenticate::checkIfLoggedIn()){
			$t->discard_block("root", "SiteKeyImagesBL");
			$t->discard_block("root", "PasswordBL");
			$t->discard_block("root", "AccountBL");
			
			$t->set_var("ERROR_MESSAGE", WebUtil::htmlOutput("You must be logged in to select a new site key."));
			$t->pparse("OUT","root");
			exit;
		}
		
		$t->discard_block("root", "PasswordBL");
		$t->discard_block("root", "AccountBL");
		$t->discard_block("root", "ErrorBL");
		
		$authObj = new Authenticate();
		
		$numberOfColumns = 3;
		
		$numberOfRows = $maxSiteKeyID / $numberOfColumns;
		
		$t->set_block("root","SiteKeyRowBL","SiteKeyRowBLout");
		
		for($i=0; $i<$numberOfRows; $i++){
			
			$t->set_var("SITE_KEY_COL1", $i*$numberOfColumns+1);
			$t->set_var("SITE_KEY_COL2", $i*$numberOfColumns+2);
			$t->set_var("SITE_KEY_COL3", $i*$numberOfColumns+3);
			
			$t->parse("SiteKeyRowBLout","SiteKeyRowBL",true);
		}
		
		$t->pparse("OUT","root");
		exit;
		
	}
	else if($action == "SaveSiteKey"){
		
		$authObj = new Authenticate();
		$accountID = $authObj->getAccountID();
		
		$siteKeyDescNoSpaces = preg_replace('/\s/', "", $siteKeyDesc);
		
		if(strlen($siteKeyDescNoSpaces) < 4)
			throw new Exception("Can not save the SiteKey because the Description less than 4 characters.");
			
		if($siteKeyID < 1 || $siteKeyID > $maxSiteKeyID)
			throw new Exception("Can not save the SiteKey because the ID is invalid.");
			
		$inventorObj = new Inventor();
		$inventorObj->loadInventor($accountID);

		$inventorObj->updateImageDesc($siteKeyDesc);
		$inventorObj->updateImageID($siteKeyID);
			
		$dbCmd->UpdateQuery("inventors", array("ImageID"=>$siteKeyID, "ImageDescription"=>$siteKeyDesc), "ID=$accountID");
		
		header("Location: " . WebUtil::filterURL($forward));
		exit;
		
	}
	else if($action == "checkUserNamePassword"){
		
		$t->discard_block("root", "SiteKeyImagesBL");
		$t->discard_block("root", "PasswordBL");
		$t->discard_block("root", "AccountBL");
		
		sleep(2);
		
		$loginResult = Authenticate::checkUserNamePass($account, $pw);
		if($loginResult == "OK"){
			
			$inventorID = $inventorObj->getInventorID($account);
			
			$inventorObj = new Inventor();
			$inventorObj->loadInventor($inventorID);
			
			// Log them in through the session.
			// Determine if they chose to stay permanently logged in.
			if($rememberPassword == "yes"){
				$permanentLoginFlag = true;
			}
			else{
				$permanentLoginFlag = false;
			}
			
			Authenticate::setAccountIDLoggedIn($inventorID, $permanentLoginFlag);

			WebUtil::SetCookie("LastAccountNameLoggedIn", $account, 300);
			
			// If the user doesn't have a Site Key Saved yet, then redirect them to the URL for selecting one.
			// Don't use a "header redirect". Otherwise the Cookies might not get sent the web browser.
			if($inventorObj->getImageDesc() == ""){
				print "<html><script>document.location='".WebUtil::filterURL("login.php?forward=" . urlencode($forward) . "&action=ShowSiteKeySelections&form_sc=" . WebUtil::getFormSecurityCode())."';</script></html>";
			}
			else{
				print "<html><script>document.location='".WebUtil::filterURL($forward)."';</script></html>";
			}
			
			exit;
		}
		else{
			$t->set_var("ERROR_MESSAGE", WebUtil::htmlOutput($loginResult) . "<div><a href='javascript:history.back()' class='BlueRedLink'>Try Again?</a></div>");
			$t->allowVariableToContainBrackets("ERROR_MESSAGE");
			$t->pparse("OUT","root");
			exit;
		}
		
	}
	else{
		throw new Exception("Illegal Action sent.");
	}
}


// If they are already logged in, then they don't need to be at this page.
if(Authenticate::checkIfLoggedIn()){
	header("Location: " . WebUtil::filterURL($forward));
	exit;
}


// Find out if we have the inventor's account name stored in a cookie.
if(empty($account)){
	$account = WebUtil::GetCookie("LastAccountNameLoggedIn");
}

$t->set_var("ACCOUNT_NAME", WebUtil::htmlOutput($account));
	
// If we still don't have an account name then we need to show a form asking for one.
if(empty($account) || !empty($changeAccountName)){
	
	$t->discard_block("root", "SiteKeyImagesBL");
	$t->discard_block("root", "PasswordBL");
	$t->discard_block("root", "ErrorBL");
	
}
else{
	
	$t->discard_block("root", "SiteKeyImagesBL");
	$t->discard_block("root", "AccountBL");
	
	if(!$inventorObj->checkIfNameExists($account)){
		$t->discard_block("root", "ExistingSiteKeyBL");
		$t->discard_block("root", "PasswordInputFieldBL");
		
		$t->set_var("ERROR_MESSAGE", WebUtil::htmlOutput("The following account name does not exist yet."));
		$t->pparse("OUT","root");
		exit;
	}
	else{
		$t->discard_block("root", "ErrorBL");
	}
	
	// Find out if the user has saved their Site Key yet.
	$dbCmd->Query("SELECT ImageID, ImageDescription FROM inventors WHERE ID =" . intval($inventorObj->getInventorID($account)));
	$row = $dbCmd->GetRow();

	if(empty($row["ImageDescription"])){
		$t->discard_block("root", "ExistingSiteKeyBL");
	}
	else{
		
		$t->set_var("SITE_KEY_ID", WebUtil::htmlOutput($row["ImageID"]));
		$t->set_var("SITE_KEY_DESC", WebUtil::htmlOutput($row["ImageDescription"]));
	}
}
	


$t->pparse("OUT","root");


